# ImageBinarization
[![][action-img]][action-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]

A Julia package containing a number of algorithms for analyzing images and
automatically binarizing them into background and foreground.

In simple words, the general usage pattern of this package is:

```julia
imgb = binarize(img, algorithm::AbstractImageBinarizationAlgorithm)
```

For more detailed usage and a full list of algorithms, please check the [documentation][docs-stable-url].

## Examples of ImageBinarization in action

### Example: cells

<table width="500" border="0" cellpadding="5">

<tr>
<td align="center" valign="center">
<img src="docs/src/images/cells.jpg" width="100px" alt="Original image" />
<br />
Original image
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/cells_Intermodes.jpg" width="100px" alt="Intermodes" />
<br />
Intermodes
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_MinimumError.jpg" width="100px" alt="Minimum Error" />
<br />
Minimum Error
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_MinimumIntermodes.jpg" width="100px" alt="Minimum" />
<br />
Minimum
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/cells_Moments.jpg" width="100px" alt="Moments" />
<br />
Moments
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_otsu.jpg" width="100px" alt="Otsu" />
<br />
Otsu
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_Polysegment.jpg" width="100px" alt="Polysegment" />
<br />
Polysegment
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/cells_UnimodalRosin.jpg" width="100px" alt="Rosin" />
<br />
Rosin
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_sauvola.png" width="100px" alt="Sauvola" />
<br />
Sauvola
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_niblack.png" width="100px" alt="Niblack" />
<br />
Niblack
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/cells_Adaptive.jpg" width="100px" alt="Adaptive" />
<br />
Adaptive
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_Yen.jpg" width="100px" alt="Yen" />
<br />
Yen
</td>

<td align="center" valign="center">
<img src="docs/src/images/cells_Balanced.jpg" width="100px" alt="Balanced" />
<br />
Balanced
</td>
</tr>
</table>

### Example: moon surface -- Unimodal

<table width="500" border="0" cellpadding="5">

<tr>
<td align="center" valign="center">
<img src="docs/src/images/moon.jpg" width="100px" alt="Original image" />
<br />
Original image
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/moon_Intermodes.jpg" width="100px" alt="Intermodes" />
<br />
Intermodes
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_MinimumError.jpg" width="100px" alt="Minimum Error" />
<br />
Minimum Error
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_MinimumIntermodes.jpg" width="100px" alt="Minimum" />
<br />
Minimum
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/moon_Moments.jpg" width="100px" alt="Moments" />
<br />
Moments
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_otsu.jpg" width="100px" alt="Otsu" />
<br />
Otsu
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_Polysegment.jpg" width="100px" alt="Polysegment" />
<br />
Polysegment
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/moon_UnimodalRosin.jpg" width="100px" alt="Rosin" />
<br />
Rosin
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_sauvola.png" width="100px" alt="Sauvola" />
<br />
Sauvola
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_niblack.png" width="100px" alt="Niblack" />
<br />
Niblack
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/moon_Adaptive.jpg" width="100px" alt="Adaptive" />
<br />
Adaptive
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_Yen.jpg" width="100px" alt="Yen" />
<br />
Yen
</td>

<td align="center" valign="center">
<img src="docs/src/images/moon_Balanced.jpg" width="100px" alt="Balanced" />
<br />
Balanced
</td>
</tr>
</table>

### Example: text

<table width="500" border="0" cellpadding="5">

<tr>
<td align="center" valign="center">
<img src="docs/src/images/page.jpg" width="100px" alt="Original image" />
<br />
Original image
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/page_Intermodes.jpg" width="100px" alt="Intermodes" />
<br />
Intermodes
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_MinimumError.jpg" width="100px" alt="Minimum Error" />
<br />
Minimum Error
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_MinimumIntermodes.jpg" width="100px" alt="Minimum" />
<br />
Minimum
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/page_Moments.jpg" width="100px" alt="Moments" />
<br />
Moments
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_otsu.jpg" width="100px" alt="Otsu" />
<br />
Otsu
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_Polysegment.jpg" width="100px" alt="Polysegment" />
<br />
Polysegment
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/page_UnimodalRosin.jpg" width="100px" alt="Rosin" />
<br />
Rosin
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_sauvola.png" width="100px" alt="Sauvola" />
<br />
Sauvola
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_niblack.png" width="100px" alt="Niblack" />
<br />
Niblack
</td>
</tr>

<tr>
<td align="center" valign="center">
<img src="docs/src/images/page_Adaptive.jpg" width="100px" alt="Adaptive" />
<br />
Adaptive
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_Yen.jpg" width="100px" alt="yen" />
<br />
Yen
</td>

<td align="center" valign="center">
<img src="docs/src/images/page_Balanced.jpg" width="100px" alt="Balanced" />
<br />
Balanced
</td>
</tr>
</table>

<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageBinarization.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[action-img]: https://github.com/JuliaImages/ImageBinarization.jl/workflows/Unit%20test/badge.svg
[action-url]: https://github.com/JuliaImages/ImageBinarization.jl/actions
[codecov-img]: https://codecov.io/gh/zygmuntszpak/ImageBinarization.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/zygmuntszpak/ImageBinarization.jl
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliaimages.org/ImageBinarization.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://juliaimages.org/ImageBinarization.jl/dev

@doc raw"""
    Niblack <: AbstractImageBinarizationAlgorithm
    Niblack(; window_size = 7, bias = 0.2)

    binarize([T,] img, f::Niblack)
    binarize!([out,] img, f::Niblack)

Applies Niblack adaptive thresholding [1] under the assumption that the input
image is textual.

# Output

Return the binarized image as an `Array{Gray{T}}` of size `size(img)`. If
`T` is not specified, it is inferred from `out` and `img`.

# Extended help

# Details

The input image is binarized by varying the threshold across the image, using
a modified version of Niblack's algorithm [2]. A threshold ``T`` is defined for
each pixel based on the mean ``m`` and standard deviation ``s`` of the
intensities of neighboring pixels in a window around it. This threshold is given
by

```math
T(x,y) = m(x,y) + k \cdot s(x,y),
```

where ``k`` is a user-defined parameter weighting the influence of the standard
deviation on the value of ``T``.

Note that Niblack's algorithm is highly sensitive to variations in the gray
values of background pixels, which often exceed local thresholds and appear as
artifacts in the binarized image. The [`Sauvola`](@ref) algorithm included in
this package implements an attempt to address this issue [2].

# Arguments

## `img`

An image which is binarized according to a per-pixel adaptive
threshold into background (0) and foreground (1) pixel values.

## `bias::Real`  (denoted by ``k`` in the publication)

A user-defined biasing parameter on threshold. This can take negative values.
Larger `bias` encourages more black pixels in the output.

## `window_size::Integer` (denoted by ``w`` in the publication)

The threshold for each pixel is a function of the distribution of the intensities
of all neighboring pixels in a square window around it. The side length of this
window is ``2w + 1``, with the target pixel in the center position.

If not specified, `window_size` is `7`.

# Example

Binarize the "cameraman" image in the `TestImages` package.

```julia
using TestImages, ImageBinarization

img = testimage("cameraman")
img₀₁ = binarize(img, Niblack())
```

# References

[1] Wayne Niblack (1986). *An Introduction to Image Processing*. Prentice-Hall, Englewood Cliffs, NJ: 115-16.
[2] J. Sauvola and M. Pietikäinen (2000). "Adaptive document image binarization". *Pattern Recognition* 33 (2): 225-236. [doi:10.1016/S0031-3203(99)00055-2](https://doi.org/10.1016/S0031-3203(99)00055-2)
"""
struct Niblack <: AbstractImageBinarizationAlgorithm
    window_size::Int
    bias::Float32

    function Niblack(window_size::Integer, bias::Real)
        window_size < 0 && throw(ArgumentError("window_size should be non-negative."))
        new(window_size, bias)
    end
end

Niblack(; window_size::Integer=7, bias::Real=0.2) = Niblack(window_size, bias)

function (f::Niblack)(out::GenericGrayImage,
                      img::GenericGrayImage)
    img = of_eltype(floattype(eltype(img)), img)

    size(out) == size(img) || throw(ArgumentError("out and img should have the same shape, instead they are $(size(out)) and $(size(img))"))

    k = f.bias
    img_raw = channelview(img)
    I = integral_image(img_raw)
    I² = integral_image(img_raw.^2)

    function threshold(pixel::CartesianIndex{2})
        row₀, col₀, row₁, col₁ = get_window_bounds(img, pixel, f.window_size)
        m = μ_in_window(I, row₀, col₀, row₁, col₁)
        s = σ_in_window(I², m, row₀, col₀, row₁, col₁)
        return m + (k * s)
    end

    @simd for pixel in CartesianIndices(img)
        out[pixel] = img[pixel] <= threshold(pixel) ? 0 : 1
    end

    return out
end

function (f::Niblack)(out::GenericGrayImage, img::AbstractArray{<:Color3})
    # map `img` to grayspace while keeping the storage type
    # TODO: this mapping operation can be done lazily to reduce memory allocation
    GT = base_color_type(eltype(out)){eltype(eltype(img))}
    f(out, GT.(img))
end

@doc raw"""
    AdaptiveThreshold <: AbstractImageBinarizationAlgorithm
    AdaptiveThreshold([img]; [window_size,] percentage = 15)

    binarize([T,] img, f::AdaptiveThreshold)
    binarize!([out,] img, f::AdaptiveThreshold)

Binarize `img` using a threshold that varies according to background
illumination.

# Output

Return the binarized image as an `Array{Gray{T}}` of size `size(img)`. If
`T` is not specified, it is inferred from `out` and `img`.

# Extended help

# Details

If the value of a pixel is `t` percent less than the average of an ``s
\times s`` window of pixels centered around the pixel, then the pixel is set
to black, otherwise it is set to white.

A computationally efficient method for computing the average of an ``s
\times s`` neighbourhood is achieved by using an *integral image*
`integral_image`.

This algorithm works particularly well on images that have distinct contrast
between background and foreground. See [1] for more details.

# Arguments

The function argument is described in more detail below.

##  `img::AbstractArray`

The image that need to be binarized. The image is automatically converted
to `Gray` in order to construct the requisite graylevel histogram.

You can also pass `img` to `AdaptiveThreshold` to automatically infer the "best"
`window_size`.

# Options

Various options for the parameters of `AdaptiveThreshold`, `binarize` and
`binarize!` are described in more detail below.

## Choices for `percentage`

You can specify an integer for the `percentage` (denoted by `t` in [1])
which must be between 0 and 100. Default: 15

## Choices for `window_size`

The argument `window_size` (denoted by `s` in [1]) specifies the size of
pixel's square neighbourhood which must be greater than zero.

If `img` is passed to `AdaptiveThreshold` constructor, then `window_size` is infered as
the integer closest to 1/8 of the average of the width and height of `img`.

# Examples

```julia
using TestImages

img = testimage("cameraman")
f = AdaptiveThreshold(window_size = 16)
img₀₁ = binarize(img, f)

f = AdaptiveThreshold(img) # infer the best `window_size` using `img`
img₀₁ = binarize(img, f)
```

See also [`binarize!`](@ref) for in-place operation.

# References

[1] Bradley, D. (2007). Adaptive Thresholding using Integral Image. *Journal of Graphic Tools*, 12(2), pp.13-21. [doi:10.1080/2151237x.2007.10129236](https://doi.org/10.1080/2151237x.2007.10129236)

"""
struct AdaptiveThreshold <: AbstractImageBinarizationAlgorithm
    window_size::Int
    percentage::Float64

    function AdaptiveThreshold(window_size::Integer, percentage::Real)
        window_size < 0 && throw(ArgumentError("window_size should be non-negative."))
        (percentage < 0 || percentage > 100) && throw(ArgumentError("percentage should be ∈ [0, 100]."))
        new(window_size, percentage)
    end
end

function AdaptiveThreshold(img::Union{AbstractArray, Nothing}=nothing;
                           window_size::Union{Integer, Nothing} = nothing,
                           percentage::Real = 15)
    if window_size == nothing
        if img == nothing
            depwarn("deprecated: without img given, window_size will be required in the future.", :AdaptiveThreshold)
            window_size = 32
            # Deprecated in ImageBinarization v0.3
            # throw(ArgumentError("window_size is required without img given"))
        else
            window_size = round(Int, mean(size(img))/8)
        end
    end
    return AdaptiveThreshold(window_size, percentage)
end


function (f::AdaptiveThreshold)(out::GenericGrayImage,
                                img::GenericGrayImage)

    size(out) == size(img) || throw(ArgumentError("out and img should have the same shape, instead they are $(size(out)) and $(size(img))"))

    rₛ = CartesianIndex(Tuple(repeated(f.window_size ÷ 2, ndims(img))))
    R = CartesianIndices(img)
    p_first, p_last = first(R), last(R)

    integral_img = integral_image(img)
    @simd for p in R
        p_tl = max(p_first, p - rₛ)
        p_br = min(p_last, p + rₛ)
        # can we pre-calculate this before the for-loop?
        total = boxdiff(integral_img, p_tl, p_br)
        count = length(_colon(p_tl, p_br))
        if img[p] * count <= total * ((100 - f.percentage) / 100)
            out[p] = 0
        else
            out[p] = 1
        end
    end
    out
end

# first do Color3 to Gray conversion
function (f::AdaptiveThreshold)(out::GenericGrayImage, img::AbstractArray{<:Color3}, args...; kwargs...)
    # map `img` to grayspace while keeping the storage type
    # TODO: this mapping operation can be done lazily to reduce memory allocation
    GT = base_color_type(eltype(out)){eltype(eltype(img))}
    f(out, GT.(img), args...; kwargs...)
end

@testset "Util" begin

    # Test `get_window_bounds()`.
    let A = Gray.(zeros(5,5))
        for index in CartesianIndices(A)
            bounds = ImageBinarization.get_window_bounds(A, index, 1)
            for bound = bounds
                @test 1 <= bound <= 5
            end
        end
    end

    # Test `μ_in_window()`.
    let A = [(x-1) * 5 + y for x = 1:5, y = 1:5]
        I = ImageBinarization.integral_image(A)
        for r₀ in 1:5, c₀ in 1:5
            for r₁ in r₀:5, c₁ in c₀:5
                @test ImageBinarization.μ_in_window(I, r₀, c₀, r₁, c₁) == mean(vec(A[r₀:r₁,c₀:c₁]))
            end
        end
    end

    # Test `σ²_in_window()`.
    let A = [(x-1) * 5 + y for x = 1:5, y = 1:5]
        I² = ImageBinarization.integral_image(A.^2)
        for r₀ in 1:5, c₀ in 1:5
            for r₁ in r₀:5, c₁ in c₀:5
                μ = mean(vec(A[r₀:r₁,c₀:c₁]))
                δ = ImageBinarization.σ²_in_window(I², μ, r₀, c₀, r₁, c₁) - var(vec(A[r₀:r₁,c₀:c₁]), corrected=false)
                @test δ == NaN || δ < 1e-10
            end
        end
    end

    # Test `σ_in_window()`.
    let A = [(x-1) * 5 + y for x = 1:5, y = 1:5]
        I² = ImageBinarization.integral_image(A.^2)
        for r₀ in 1:5, c₀ in 1:5
            for r₁ in r₀:5, c₁ in c₀:5
                μ = mean(vec(A[r₀:r₁,c₀:c₁]))
                δ = ImageBinarization.σ_in_window(I², μ, r₀, c₀, r₁, c₁) - std(vec(A[r₀:r₁,c₀:c₁]), corrected=false)
                @test δ == NaN || δ < 1e-10
            end
        end
    end
end

"""
    Sauvola <: AbstractImageBinarizationAlgorithm
    Sauvola(; bias = 0.2, window_size=7)

    binarize([T,] img, f::Sauvola)
    binarize!([out,] img, f::Sauvola)

Applies Sauvola--Pietikäinen adaptive image binarization [1] under the
assumption that the input image is textual.

# Output

Return the binarized image as an `Array{Gray{T}}` of size `size(img)`. If
`T` is not specified, it is inferred from `out` and `img`.

# Extended help

# Details

The input image is binarized by varying the threshold across the image, using
a modified version of Niblack's algorithm [2]. Niblack's approach was to define
a threshold ``T`` for each pixel based on the mean ``m`` and standard deviation
``s`` of the intensities of neighboring pixels in a window around it, given by

```math
T(x,y) = m(x,y) + k \\cdot s(x,y),
```

where ``k`` is a user-defined parameter weighting the influence of the standard
deviation on the value of ``T``.

Niblack's algorithm is highly sensitive to variations in the gray values of
background pixels, which often exceed local thresholds and appear as artifacts
in the binarized image. Sauvola and Pietikäinen [1] introduce the dynamic range
``R`` of the standard deviation (i.e. its maximum possible value in the color
space), such that the threshold is given by

```math
T(x,y) = m(x,y) \\cdot \\left[ 1 + k \\cdot \\left( \\frac{s(x,y)}{R} - 1 \\right) \\right]
```

This adaptively amplifies the contribution made by the standard deviation to the
value of ``T``.

The Sauvola--Pietikäinen algorithm is implemented here using an optimization
proposed by Shafait, Keysers and Breuel [3], in which integral images are used
to calculate the values of ``m`` and ``s`` for each pixel in constant time.
Since each of these data structures can be computed in a single pass over the
source image, runtime is significantly improved.

# Arguments

## `img`

An image which is binarized according to a per-pixel adaptive
threshold into background (0) and foreground (1) pixel values.

## `window_size::Integer` (denoted by ``w`` in the publication)

The threshold for each pixel is a function of the distribution of the intensities
of all neighboring pixels in a square window around it. The side length of this
window is ``2w + 1``, with the target pixel in the center position.

## `bias::Real` (denoted by ``k`` in the publication)

A user-defined biasing parameter. This can take negative values, though values
in the range [0.2, 0.5] are typical. According to [1], this algorithm is not too
sensitive to the value of ``k```.

# Example

Binarize the "cameraman" image in the `TestImages` package.

```julia
using TestImages, ImageBinarization

img = testimage("cameraman")
img_binary = binarize(img, Sauvola(window_size = 9, bias = 0.2))
```

# References

1. J. Sauvola and M. Pietikäinen (2000). "Adaptive document image binarization". *Pattern Recognition* 33 (2): 225-236. [doi:10.1016/S0031-3203(99)00055-2](https://doi.org/10.1016/S0031-3203(99)00055-2)
2. Wayne Niblack (1986). *An Introduction to Image Processing*. Prentice-Hall, Englewood Cliffs, NJ: 115-16.
3. Faisal Shafait, Daniel Keysers and Thomas M. Breuel (2008). "Efficient implementation of local adaptive thresholding techniques using integral images". Proc. SPIE 6815, Document Recognition and Retrieval XV, 681510 (28 January 2008). [doi:10.1117/12.767755](https://doi.org/10.1117/12.767755)
"""
struct Sauvola <: AbstractImageBinarizationAlgorithm
    window_size::Int
    bias::Float32

    function Sauvola(window_size::Integer, bias::Real)
        window_size < 0 && throw(ArgumentError("window_size should be non-negative."))
        new(window_size, bias)
    end
end

Sauvola(; window_size::Int = 7, bias::Real = 0.2) = Sauvola(window_size, bias)

function (f::Sauvola)(out::GenericGrayImage, img::GenericGrayImage)
    img = of_eltype(floattype(eltype(img)), img)

    window_size = f.window_size
    k = f.bias

    size(out) == size(img) || throw(ArgumentError("out and img should have the same shape, instead they are $(size(out)) and $(size(img))"))

    img_raw = channelview(img)
    I = integral_image(img_raw)
    I² = integral_image(img_raw.^2)
    R = 0.5 # dynamic range of standard deviation, in [1] it's set to 128 for 8-bit image

    function threshold(pixel::CartesianIndex{2})
        row₀, col₀, row₁, col₁ = get_window_bounds(img, pixel, window_size)
        m = μ_in_window(I, row₀, col₀, row₁, col₁)
        s = σ_in_window(I², m, row₀, col₀, row₁, col₁)
        return m * (1 + (k * ((s / R) - 1)))
    end

    @simd for pixel in CartesianIndices(img)
        out[pixel] = img[pixel] <= threshold(pixel) ? 0 : 1
    end

    return out
end

function (f::Sauvola)(out::GenericGrayImage, img::AbstractArray{<:Color3})
    # map `img` to grayspace while keeping the storage type
    # TODO: this mapping operation can be done lazily to reduce memory allocation
    GT = base_color_type(eltype(out)){eltype(eltype(img))}
    f(out, GT.(img))
end

using Documenter, ImageBinarization
makedocs(sitename="Documentation",
    format = Documenter.HTML(
        prettyurls = get(ENV, "CI", nothing) == "true"
    ),
    pages = [
        "Home" => "index.md",
        "Function Reference" => "reference.md"
    ]
)
deploydocs(repo = "github.com/JuliaImages/ImageBinarization.jl.git")

# Alternatively, we could use `InteractiveUtils.subtypes` to get a list of it.
threshold_methods = (
    Balanced,
    Entropy,
    Intermodes,
    MinimumError,
    MinimumIntermodes,
    Moments,
    Otsu,
    UnimodalRosin,
    Yen
)

"""
    SingleHistogramThreshold <: AbstractImageBinarizationAlgorithm
    SingleHistogramThreshold(alg::AbstractThresholdAlgorithm; nbins=256)

    binarize([T,] img, f::AbstractThresholdAlgorithm; nbins=256)
    binarize!([out,] img, f::AbstractThresholdAlgorithm; nbins=256)

Binarizes the image `img` using the threshold found by given threshold finding algorithm `alg`.

# Output

Return the binarized image as an `Array{Gray{T}}` of size `size(img)`. If `T` is not specified, it
is inferred from `out` and `img`.

# Arguments

The function argument is described in more detail below.

##  `img::AbstractArray`

The image that needs to be binarized.  The image is automatically converted to `Gray` in order to
construct the requisite graylevel histogram.

## `alg::AbstractThresholdAlgorithm`

`AbstractThresholdAlgorithm` is an abstract type defined in `ThresholdAPI.jl` in the
`HistogramThreshold.jl` package, it provides various threshold finding algorithms:

$(mapreduce(x->"- `"*string(x)*"`", (x,y)->x*"\n"*y, threshold_methods))

For the more detailed explaination and the construction, please refer to each concrete algorithm.
For example, type `?Otsu` in REPL will give you more details on how to use `Otsu` methods.

## `nbins::Integer`

The number of discrete bins that used to build the histogram. A smaller `nbins` could possibly gives
a less noisy, or in other words, a smoother output. The default value is `256`.

# Examples

All the usage follows the same pattern, take `Otsu` as an example:

```julia
using TestImages, ImageBinarization

img = testimage("cameraman")
img_binary = binarize(img, Otsu())
```

It is less convenient, but still, you could also construct a `SingleHistogramThreshold` by yourself:

```julia
using TestImages, ImageBinarization

img = testimage("cameraman")
f = SingleHistogramThreshold(Otsu(), nbins=256)
img_binary = binarize(img, f)
```

"""
struct SingleHistogramThreshold{T} <: AbstractImageBinarizationAlgorithm
    alg::T
    nbins::Int
    function SingleHistogramThreshold(alg::T; nbins::Integer) where T <: AbstractThresholdAlgorithm
        new{T}(alg, nbins)
    end
end

function binarize!(out::GenericGrayImage, img, f::AbstractThresholdAlgorithm, args...; nbins::Integer=256, kwargs...)
    binarize!(out, img, SingleHistogramThreshold(f, nbins=nbins), args...; kwargs...)
end
function binarize!(img::GenericGrayImage, f::AbstractThresholdAlgorithm, args...; nbins::Integer=256, kwargs...)
    binarize!(img, SingleHistogramThreshold(f, nbins=nbins), args...; kwargs...)
end
function binarize(::Type{T}, img, f::AbstractThresholdAlgorithm, args...; nbins::Integer=256, kwargs...) where T
    binarize(T, img, SingleHistogramThreshold(f, nbins=nbins), args...; kwargs...)
end
function binarize(img, f::AbstractThresholdAlgorithm, args...; nbins::Integer=256, kwargs...)
    binarize(ccolor(Gray, eltype(img)), img, SingleHistogramThreshold(f, nbins=nbins), args...; kwargs...)
end
function binarize(img::AbstractArray{T}, f::AbstractThresholdAlgorithm, args...; kwargs...) where T <: Number
    # issue #46: Do not promote Number to Gray{<:Number}
    binarize(T, img, f, args...; kwargs...)
end


function (f::SingleHistogramThreshold)(out::GenericGrayImage, img::GenericGrayImage)
    edges, counts = build_histogram(img, f.nbins)
    t = find_threshold(f.alg, counts[1:end], edges)
    @. out = img > t # here we rely on implicit type conversion to `eltype(out)`
end

function (f::SingleHistogramThreshold)(out::GenericGrayImage, img::AbstractArray{<:Color3})
    # map `img` to grayspace while keeping the storage type
    # TODO: this mapping operation can be done lazily to reduce memory allocation
    GT = base_color_type(eltype(out)){eltype(eltype(img))}
    f(out, GT.(img))
end

using Base: depwarn

# issue #23: swap argument order
# Deprecated in ImageBinarization v0.3
function binarize(f::AbstractImageBinarizationAlgorithm, img::AbstractArray, args...; kwargs...)
    depwarn("binarize(alg, img) is deprecated, use binarize(img, alg) instead", :binarize)
    binarize(img, f, args...; kwargs...)
end

# unexport recommend_size
# Deprecated in ImageBinarization v0.3
function recommend_size(img)
    depwarn("recommend_size is deprecated, use AdaptiveThreshold(img) to directly generate the algorithm", :recommend_size)
    return round(Int, mean(size(img))/8)
end

#=
Copied from https://github.com/JuliaImages/Images.jl/blob/master/src/algorithms.jl
to ensure that this package doesn't need to depend on Images.jl.
In future the intergral image code should be its own package.
Work in this direction already started here:
https://github.com/JuliaImages/IntegralArrays.jl
=#

"""
```
integral_img = integral_image(img)
```
Returns the integral image of an image. The integral image is calculated by assigning
to each pixel the sum of all pixels above it and to its left, i.e. the rectangle from
(1, 1) to the pixel. An integral image is a data structure which helps in efficient
calculation of sum of pixels in a rectangular subset of an image. See `boxdiff` for more
information.
"""
function integral_image(img::AbstractArray)
    integral_img = Array{accum(eltype(img))}(undef, size(img))
    sd = coords_spatial(img)
    cumsum!(integral_img, img, dims=sd[1])
    for i = 2:length(sd)
        cumsum!(integral_img, integral_img, dims=sd[i])
    end
    integral_img
end

"""
```
sum = boxdiff(integral_image, ytop:ybot, xtop:xbot)
sum = boxdiff(integral_image, CartesianIndex(tl_y, tl_x), CartesianIndex(br_y, br_x))
sum = boxdiff(integral_image, tl_y, tl_x, br_y, br_x)
```
An integral image is a data structure which helps in efficient calculation of sum of pixels in
a rectangular subset of an image. It stores at each pixel the sum of all pixels above it and to
its left. The sum of a window in an image can be directly calculated using four array
references of the integral image, irrespective of the size of the window, given the `yrange` and
`xrange` of the window. Given an integral image -
        A - - - - - - B -
        - * * * * * * * -
        - * * * * * * * -
        - * * * * * * * -
        - * * * * * * * -
        - * * * * * * * -
        C * * * * * * D -
        - - - - - - - - -
The sum of pixels in the area denoted by * is given by S = D + A - B - C.
"""
boxdiff(int_img::AbstractArray{T, 2}, y::UnitRange, x::UnitRange) where {T} = boxdiff(int_img, y.start, x.start, y.stop, x.stop)
boxdiff(int_img::AbstractArray{T, 2}, tl::CartesianIndex, br::CartesianIndex) where {T} = boxdiff(int_img, tl[1], tl[2], br[1], br[2])

function boxdiff(int_img::AbstractArray{T, 2}, tl_y::Integer, tl_x::Integer, br_y::Integer, br_x::Integer) where T
    sum = int_img[br_y, br_x]
    sum -= tl_x > 1 ? int_img[br_y, tl_x - 1] : zero(T)
    sum -= tl_y > 1 ? int_img[tl_y - 1, br_x] : zero(T)
    sum += tl_y > 1 && tl_x > 1 ? int_img[tl_y - 1, tl_x - 1] : zero(T)
    sum
end


accum(::Type{T}) where {T<:Integer} = Int
accum(::Type{Float32})    = Float32
accum(::Type{T}) where {T<:Real} = Float64
accum(::Type{C}) where {C<:Colorant} = base_colorant_type(C){accum(eltype(C))}

@testset "SingleHistogramThreshold" begin
    @info "Test: SingleHistogramThreshold"

    threshold_methods = [
        ("Balanced", Balanced()),
        ("Entropy", Entropy()),
        ("Intermodes", Intermodes()),
        ("MinimumError", MinimumError()),
        ("MinimumIntermodes", MinimumIntermodes()),
        ("Moments", Moments()),
        ("Otsu", Otsu()),
        ("UnimodalRosin", UnimodalRosin()),
        ("Yen", Yen()),
    ]

    @testset "API" begin
        img_gray = imresize(testimage("cameraman"); ratio=0.25)
        img = copy(img_gray)

        for (fname, f) in threshold_methods
            binarized_img = binarize(img, f)
            @test img == img_gray # img unchanged
            @test eltype(binarized_img) == Gray{N0f8}

            ref = copy(binarized_img)

            g = SingleHistogramThreshold(f, nbins=256)
            binarized_img = binarize(img, g)
            @test ref == binarized_img
            @test eltype(binarized_img) == Gray{N0f8}

            for alg in [f, g]
                binarized_img = binarize(Gray{Bool}, img, alg)
                @test img == img_gray # img unchanged
                @test eltype(binarized_img) == Gray{Bool}
                @test ref == binarized_img

                binarized_img = similar(img, Bool)
                binarize!(binarized_img, img, alg)
                @test img == img_gray # img unchanged
                @test eltype(binarized_img) == Bool
                @test ref == binarized_img

                binarized_img = copy(img_gray)
                binarize!(binarized_img, alg)
                @test eltype(binarized_img) == Gray{N0f8}
                @test ref == binarized_img
            end

            # binarize for SingleHistogramThreshold does not accept keyword `nbins`
            binarized_img = binarize(img, f, nbins=256)
            @test img == img_gray
            @test eltype(binarized_img) == Gray{N0f8}
            @test ref == binarized_img

            for T in generate_test_types([Float32, N0f8, Bool], [Gray])
                @test eltype(binarize(T, img, f)) == T
            end
        end
    end

    @testset "Types" begin
        # Gray
        img_gray = imresize(testimage("lena_gray_256"); ratio=0.25)
        for (fname, f) in threshold_methods
            type_list = generate_test_types([Float32, N0f8], [Gray])
            for T in type_list
                img = T.(img_gray)
                reffile = joinpath("References", fname*"_Gray.png")
                @test_reference reffile Gray.(binarize(img, f)) by=binarization_equality()
            end 
        end

        # Color3
        img_color = imresize(testimage("lena_color_256"); ratio=0.25)
        for (fname, f) in threshold_methods
            type_list = generate_test_types([Float32, N0f8], [RGB, Lab])
            for T in type_list
                img = T.(img_gray)
                reffile = joinpath("References", fname*"_Color3.png")
                @test_reference reffile Gray.(binarize(img, f)) by=binarization_equality()
            end
        end

        # issue #83
        @testset "explicit Bool type" begin
            img_ori = imresize(testimage("cameraman"); ratio=0.25)
            for T in [RGB, Gray]
                img = T.(img_ori)
                for (fname, f) in threshold_methods
                    for out_T in [Gray{Bool}, Bool]
                        @test binarize(out_T, img, f) == out_T.(binarize(img, f))
                    end
                end
            end
        end
    end

    @testset "Numerical" begin
        # Check that the image only has ones or zeros.
        img = imresize(testimage("lena_gray_256"); ratio=0.25)
        for (fname, f) in threshold_methods
            img₀₁ = binarize(img, f)
            non_zeros = findall(x -> x != 0.0 && x != 1.0, img₀₁)
            @test length(non_zeros) == 0

            # Check that ones and zeros have been assigned to the correct side of the threshold.
            maxval, maxpos = findmax(Gray.(img))
            @test img₀₁[maxpos] == 1
            minval, minpos = findmin(Gray.(img))
            @test img₀₁[minpos] == 0
        end
    end

    @testset "Offset Arrays" begin
        # Verify that the algorithms give equivalent results on OffsetArrays
        img = imresize(testimage("cameraman"); ratio=0.25)
        offset_img = OffsetArray(img, OffsetArrays.Origin(0))
        for (fname, f) in threshold_methods
            img₀₁ = binarize(img, f)
            offset_img₀₁ = binarize(offset_img, f)
            @test axes(offset_img₀₁) == axes(offset_img)
            @test img₀₁ == OffsetArrays.no_offset_view(offset_img₀₁)
        end
    end
end

"""
    _colon(I, J)

`_colon(I, J)` works equivelently to `I:J`, it's used to backward support julia v"1.0".
"""
_colon(I, J) = I:J
if v"1.0" <= VERSION < v"1.1"
    _colon(I::CartesianIndex{N}, J::CartesianIndex{N}) where N =
        CartesianIndices(map((i,j) -> i:j, Tuple(I), Tuple(J)))
end

module ImageBinarization

using Base.Iterators: repeated
using LinearAlgebra
using Polynomials
using Statistics
using Reexport

@reexport using HistogramThresholding

using ImageCore
using ImageCore.MappedArrays
using ImageCore: GenericGrayImage

# TODO: port BinarizationAPI to ImagesAPI
include("BinarizationAPI/BinarizationAPI.jl")
import .BinarizationAPI: AbstractImageBinarizationAlgorithm,
                         binarize, binarize!
import HistogramThresholding: AbstractThresholdAlgorithm

include("integral_image.jl")
include("util.jl")
include("compat.jl")

# Concrete binarization algorithms

# Balanced, Entropy, Intermodes, Minimum, MinimumError, Moments, Otsu, UnimodalRosin, Yen
include("algorithms/single_histogram_threshold.jl")
include("algorithms/adaptive_threshold.jl") # AdaptiveThreshold
include("algorithms/niblack.jl") # Niblack
include("algorithms/polysegment.jl") # Polysegment
include("algorithms/sauvola.jl") # Sauvola

include("deprecations.jl")

export
    # generic API
    binarize, binarize!,

    # Algorithms
    AdaptiveThreshold, recommend_size,
    Niblack,
    Polysegment,
    Sauvola,

    # also reexport algorithms in HistogramThresholding
    SingleHistogramThreshold

end # module ImageBinarization

function get_window_bounds(img::GenericGrayImage, pixel::CartesianIndex{2}, w::Integer)
    row, col = pixel.I
    min_row, min_col = first.(axes(img))
    max_row, max_col = last.(axes(img))

    row₀ = max(row - w, min_row)
    col₀ = max(col - w, min_col)
    row₁ = min(row + w, max_row)
    col₁ = min(col + w, max_col)

    return row₀, col₀, row₁, col₁
end

function μ_in_window(I::AbstractArray{T,2}, row₀::Integer, col₀::Integer, row₁::Integer, col₁::Integer) where T <: Real
    μ = boxdiff(I, row₀:row₁, col₀:col₁) / ((row₁-row₀+1)*(col₁-col₀+1))
    return μ < eps() ? zero(eltype(I)) : μ
end

function σ²_in_window(I²::AbstractArray{T,2}, μ::Real, row₀::Integer, col₀::Integer, row₁::Integer, col₁::Integer) where T <: Real
    σ² = μ_in_window(I², row₀, col₀, row₁, col₁) - μ^2
    return σ² < eps() ? zero(eltype(I²)) : σ²
end

function σ_in_window(I²::AbstractArray{T,2}, μ::Real, row₀::Integer,  col₀::Integer, row₁::Integer, col₁::Integer) where T <: Real
    σ² = σ²_in_window(I², μ, row₀, col₀, row₁, col₁)
    return σ² < eps() ? zero(eltype(I²)) : sqrt(σ²)
end

using ImageBinarization
using Test, TestImages
using Statistics
using ImageCore, ImageTransformations
using OffsetArrays
using ReferenceTests

include("testutils.jl")

@testset "ImageBinarization.jl" begin
    include("util.jl")

    include("algorithms/single_histogram_threshold.jl")
    include("algorithms/adaptive_threshold.jl")
    include("algorithms/niblack.jl")
    include("algorithms/polysegment.jl")
    include("algorithms/sauvola.jl")
end

nothing

"""
    Polysegment <: AbstractImageBinarizationAlgorithm
    Polysegment()

    binarize([T,] img, f::Polysegment)
    binarize!([out,] img, f::Polysegment)

Uses the *polynomial segmentation* technique to group the image pixels
into two categories (foreground and background).

# Output

Return the binarized image as an `Array{Gray{T}}` of size `size(img)`. If
`T` is not specified, it is inferred from `out` and `img`.

# Extended help

# Details

The approach involves constructing a univariate second-degree polynomial
such that the two roots of the polynomial represent the graylevels
of two cluster centers (i.e the foreground and background). Pixels are then
assigned to the foreground or background depending on which cluster center
is closest.

# Arguments

The function argument is described in more detail below.

##  `img::AbstractArray`

The image that needs to be binarized. The image is automatically converted
to `Gray`.


# Example

Binarize the "cameraman" image in the `TestImages` package.

```julia
using TestImages, ImageBinarization

img = testimage("cameraman")
img_binary = binarize(img, Polysegment())
```

## Reference

1. R. E. Vidal, "Generalized Principal Component Analysis (GPCA): An Algebraic Geometric Approach to Subspace Clustering and Motion Segmentation." Order No. 3121739, University of California, Berkeley, Ann Arbor, 2003.
"""
struct Polysegment <: AbstractImageBinarizationAlgorithm end

function (f::Polysegment)(out::GenericGrayImage, img::GenericGrayImage)
  # Construct data matrix for second-degree polynomial (Equation 2.3) in [1].
  x = vec(img)
  Lₙ = hcat(ones(length(x)), x, x.^2)
  F = svd(Lₙ)
  c = F.Vt[end,:]
  p = Polynomial(vec(c))
  μ₁, μ₂ = sort(roots(p))
  # Binarize the image.
  @simd for i in CartesianIndices(img)
    val = img[i]
    out[i] = (val-μ₁)^2 < (val-μ₂)^2 ? 0 : 1
  end
  out
end

function (f::Polysegment)(out::GenericGrayImage, img::AbstractArray{<:Color3})
    # map `img` to grayspace while keeping the storage type
    # TODO: this mapping operation can be done lazily to reduce memory allocation
    GT = base_color_type(eltype(out)){eltype(eltype(img))}
    f(out, GT.(img))
end
  

# usage example for package developer:
#
#     import BinarizationAPI: AbstractImageBinarizationAlgorithm,
#                             binarize, binarize!

"""
    AbstractImageBinarizationAlgorithm <: AbstractImageFilter

The root type for `ImageBinarization` package.

Any concrete binarization algorithm shall subtype it to support
[`binarize`](@ref) and [`binarize!`](@ref) APIs.

# Examples

All algorithms in ImageBinarization are called in the following pattern:

```julia
# first generate an algorithm instance
f = Otsu()

# then pass the algorithm to `binarize`
img₀₁ = binarize(img, f) # `eltype(img₀₁)` is `Gray{N0f8}`

# or use in-place version `binarize!`
img₀₁ = similar(img)
binarize!(img₀₁, img, f)
```

Some algorithms also receive additional information of image as an argument to infer the
"best" parameters, e.g., `window_size` of `AdaptiveThreshold`.

```julia
# you could explicit specify the it
f = AdaptiveThreshold(window_size = 32)

# or infer the "best" default value from given image
img = testimage("cameraman")
f = AdaptiveThreshold(img)
```

For more examples, please check [`binarize`](@ref) and [`binarize!`](@ref) and concret
algorithms.
"""
abstract type AbstractImageBinarizationAlgorithm <: AbstractImageFilter end

binarize!(out::GenericGrayImage,
          img,
          f::AbstractImageBinarizationAlgorithm,
          args...; kwargs...) =
    f(out, img, args...; kwargs...)

# in-place binarize! only supports gray image input
function binarize!(img::GenericGrayImage,
                   f::AbstractImageBinarizationAlgorithm,
                   args...; kwargs...)
    tmp = copy(img)
    f(img, tmp, args...; kwargs...)
    return img
end

function binarize(::Type{T},
                  img,
                  f::AbstractImageBinarizationAlgorithm,
                  args...; kwargs...) where T
    out = similar(Array{T}, axes(img))
    binarize!(out, img, f, args...; kwargs...)
    return out
end

binarize(img::AbstractArray{T},
         f::AbstractImageBinarizationAlgorithm,
         args...; kwargs...) where T <: Colorant =
    binarize(Gray{eltype(T)}, img, f, args...; kwargs...)

# issue #46: Do not promote Number to Gray{<:Number}
binarize(img::AbstractArray{T},
         f::AbstractImageBinarizationAlgorithm,
         args...; kwargs...) where T <: Number =
    binarize(T, img, f, args...; kwargs...)

### Docstrings

"""
    binarize!([out,] img, f::AbstractImageBinarizationAlgorithm, args...; kwargs...)

Binarize `img` using algorithm `f`.

# Output

If `out` is specified, it will be changed in place. Otherwise `img` will be changed in place.

# Examples

Just simply pass an algorithm to `binarize!`:

```julia
img₀₁ = similar(img)
binarize!(img₀₁, img, f)
```

For cases you just want to change `img` in place, you don't necessarily need to manually
allocate `img₀₁`; just use the convenient method:

```julia
binarize!(img, f)
```

See also: [`binarize`](@ref)
"""
binarize!

"""
    binarize([T::Type,] img, f::AbstractImageBinarizationAlgorithm, args...; kwargs...)

Binarize `img` using algorithm `f`.

# Output

The return image `img₀₁` is an `Array{T}`.

If `T` is not specified, then it's inferred as
`Gray{eltype(eltype(img))}`, which is `Gray{N0f8}` for img of type `Array{N0f8}` and `Array{Gray{N0f8}}`, and `Gray{Float32}` for img of type `Array{Float32}` and `Array{Gray{Float32}}`

# Examples

Just simply pass the input image and algorithm to `binarize`

```julia
img₀₁ = binarize(img, f)
```

This reads as "`binarize` image `img` using binarization algorithm `f`".

You can also explicitly specify the return type:

```julia
img₀₁_float32 = binarize(Gray{Float32}, img, f)
```

See also [`binarize!`](@ref) for in-place binarization.
"""
binarize

@testset "adaptive_threshold" begin
    @info "Test: AdaptiveThreshold"

    @testset "API" begin
        img_gray = imresize(testimage("lena_gray_256"); ratio=0.25)
        img = copy(img_gray)

        # AdaptiveThreshold
        @test AdaptiveThreshold(window_size=32) == AdaptiveThreshold(32, 15)
        @test AdaptiveThreshold(img_gray) == AdaptiveThreshold(window_size=8)

        # window_size non-positive integer
        @test_throws ArgumentError AdaptiveThreshold(window_size=-10)
        @test_throws TypeError AdaptiveThreshold(window_size=32.5)
        # percentage ∈ [0, 100]
        @test_throws ArgumentError AdaptiveThreshold(window_size=32, percentage=-10)
        @test_throws ArgumentError AdaptiveThreshold(window_size=32, percentage=150)

        # binarize
        f = AdaptiveThreshold(img, percentage=15)
        binarized_img_1 = binarize(img, f)
        @test img == img_gray # img unchanged
        @test eltype(binarized_img_1) == Gray{N0f8}

        binarized_img_2 = binarize(Gray{Bool}, img, f)
        @test img == img_gray # img unchanged
        @test eltype(binarized_img_2) == Gray{Bool}

        binarized_img_3 = similar(img, Bool)
        binarize!(binarized_img_3, img, f)
        @test img == img_gray # img unchanged
        @test eltype(binarized_img_3) == Bool

        binarized_img_4 = copy(img_gray)
        binarize!(binarized_img_4, f)
        @test eltype(binarized_img_4) == Gray{N0f8}

        @test binarized_img_1 == binarized_img_2
        @test binarized_img_1 == binarized_img_3
        @test binarized_img_1 == binarized_img_4

        for T in generate_test_types([Float32, N0f8, Bool], [Gray])
            @test eltype(binarize(T, img, f)) == T
        end
    end

    @testset "Types" begin
        # Gray
        img_gray = imresize(testimage("lena_gray_256"); ratio=0.25)
        f = AdaptiveThreshold(img_gray, percentage=15)

        type_list = generate_test_types([Float32, N0f8], [Gray])
        for T in type_list
            img = T.(img_gray)
            @test_reference "References/AdaptiveThreshold_Gray.png" Gray.(binarize(img, f)) by=binarization_equality()
        end

        # Color3
        img_color = imresize(testimage("lena_color_256"); ratio=0.25)
        f = AdaptiveThreshold(img_color, percentage=15)

        type_list = generate_test_types([Float32, N0f8], [RGB, Lab])
        for T in type_list
            img = T.(img_gray)
            @test_reference "References/AdaptiveThreshold_Color3.png" Gray.(binarize(img, f)) by=binarization_equality()
        end

        # issue #83
        @testset "explicit Bool type" begin
            img_ori = imresize(testimage("cameraman"); ratio=0.25)
            for T in [RGB, Gray]
                img = T.(img_ori)
                f = AdaptiveThreshold(img)
                for out_T in [Gray{Bool}, Bool]
                    @test binarize(out_T, img, f) == out_T.(binarize(img, f))
                end
            end
        end
    end

    @testset "Numerical" begin
        # Check that the image only has ones or zeros.
        img = imresize(testimage("lena_gray_256"); ratio=0.25)
        f = AdaptiveThreshold(img, percentage=15)
        img₀₁ = binarize(img, f)
        non_zeros = findall(x -> x != 0.0 && x != 1.0, img₀₁)
        @test length(non_zeros) == 0

        # Check that ones and zeros have been assigned to the correct side of the threshold.
        maxval, maxpos = findmax(Gray.(img))
        @test img₀₁[maxpos] == 1
        minval, minpos = findmin(Gray.(img))
        @test img₀₁[minpos] == 0
    end

    @testset "Miscellaneous" begin
        img = testimage("lena_gray_256")

        # deprecations
        @test (@test_deprecated AdaptiveThreshold()) == AdaptiveThreshold(32, 15.0)
        @test (@test_deprecated AdaptiveThreshold(percentage = 15)) == AdaptiveThreshold(32, 15)
        @test (@test_deprecated recommend_size(img)) == 32
    end

end

# AbstractGray and Color3 tests should be generated seperately
function generate_test_types(number_types::AbstractArray{<:DataType}, color_types::AbstractArray{<:UnionAll})
    test_types = map(Iterators.product(number_types, color_types)) do T
        try
            T[2]{T[1]}
        catch err
            !isa(err, TypeError) && rethrow(err)
        end
    end
    test_types = filter(x->x != false, test_types)
    if isempty(filter(x->x<:Color3, test_types))
        test_types = [number_types..., test_types...]
    end
    test_types
end

function binarization_equality(ratio = 0.0)
    function (ref, x)
        if size(ref) != size(x)
            @warn "test fails because size(ref) != size(x)"
            return false
        end

        count = sum(ref .!= x)
        max_count = ceil(Int, length(ref)*ratio)
        rst = count <= max_count
        if !rst
            @warn "$count pixels are incorrectly binarized, at most $max_count is allowed."
        end
        return rst
    end
end

# [Function References](@id function_reference)

```@contents
Pages = ["reference.md"]
Depth = 3
```

## General function

```@docs
binarize
binarize!
```

## Algorithms

```@docs
ImageBinarization.BinarizationAPI.AbstractImageBinarizationAlgorithm
```

### Adaptive Threshold
```@docs
AdaptiveThreshold
```

### Niblack
```@docs
Niblack
```

### Polysegment
```@docs
Polysegment
```

### Sauvola
```@docs
Sauvola
```

## Algorithms that utilizes single histogram-threshold

The core functionality of these algorithms are supported by
[HistogramThresholding.jl](https://github.com/JuliaImages/HistogramThresholding.jl)

```@docs
SingleHistogramThreshold
```

### Otsu
```@docs
HistogramThresholding.Otsu
```

### MinimumIntermodes
```@docs
HistogramThresholding.MinimumIntermodes
```

### Intermodes
```@docs
HistogramThresholding.Intermodes
```

### MinimumError
```@docs
HistogramThresholding.MinimumError
```

### Moments
```@docs
HistogramThresholding.Moments
```

### UnimodalRosin
```@docs
HistogramThresholding.UnimodalRosin
```

### Entropy
```@docs
HistogramThresholding.Entropy
```

### Balanced
```@docs
HistogramThresholding.Balanced
```

### Yen
```@docs
HistogramThresholding.Yen
```
